#include "NuclearDataUtils/NuclearDataObject.hpp"

using namespace frendy;

//constructor
NuclearDataObject::NuclearDataObject(void)
{
  clear();
}

//destructor
NuclearDataObject::~NuclearDataObject(void)
{
  clear();
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void NuclearDataObject::clear()
{
  general_data_obj.clear();
  fis_data_obj.clear();
  reso_data_obj.clear();
  thermal_scat_data_obj.clear();
  nucl_reaction_data_obj.clear();
  cov_general_data_obj.clear();
  cov_reso_data_obj.clear();
  cov_reaction_data_obj.clear();
  prob_data_obj.clear();
}

////////////////////////////////////////////////////////////////////////////////////////////////////

//Getter
GeneralDataContainer              NuclearDataObject::get_general_data_obj()
{
  return general_data_obj;
}

FissionDataContainer              NuclearDataObject::get_fis_data_obj()
{
  return fis_data_obj;
}

ResonanceDataContainer            NuclearDataObject::get_reso_data_obj()
{
  return reso_data_obj;
}

ThermalScatterDataContainer       NuclearDataObject::get_thermal_scat_data_obj()
{
  return thermal_scat_data_obj;
}

NuclearReactionDataContainer      NuclearDataObject::get_nucl_reaction_data_obj()
{
  return nucl_reaction_data_obj;
}

CovarianceGeneralDataContainer    NuclearDataObject::get_cov_general_data_obj()
{
  return cov_general_data_obj;
}

CovarianceResonanceDataContainer  NuclearDataObject::get_cov_reso_data_obj()
{
  return cov_reso_data_obj;
}

CovarianceReactionDataContainer   NuclearDataObject::get_cov_reaction_data_obj()
{
  return cov_reaction_data_obj;
}

ProbabilityDataContainer          NuclearDataObject::get_prob_data_obj()
{
  return prob_data_obj;
}

////////////////////////////////////////////////////////////////////////////////////////////////////

//Setter
void NuclearDataObject::set_general_data_obj( GeneralDataContainer obj_data )
{
  general_data_obj.clear();
  general_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_fis_data_obj( FissionDataContainer obj_data )
{
  fis_data_obj.clear();
  fis_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_reso_data_obj( ResonanceDataContainer obj_data )
{
  reso_data_obj.clear();
  reso_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_thermal_scat_data_obj( ThermalScatterDataContainer obj_data )
{
  thermal_scat_data_obj.clear();
  thermal_scat_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_nucl_reaction_data_obj( NuclearReactionDataContainer obj_data )
{
  nucl_reaction_data_obj.clear();
  nucl_reaction_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_cov_general_data_obj( CovarianceGeneralDataContainer obj_data )
{
  cov_general_data_obj.clear();
  cov_general_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_cov_reso_data_obj( CovarianceResonanceDataContainer obj_data )
{
  cov_reso_data_obj.clear();
  cov_reso_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_cov_reaction_data_obj( CovarianceReactionDataContainer obj_data )
{
  cov_reaction_data_obj.clear();
  cov_reaction_data_obj = obj_data;
  obj_data.clear();
}

void NuclearDataObject::set_prob_data_obj( ProbabilityDataContainer obj_data )
{
  prob_data_obj.clear();
  prob_data_obj = obj_data;
  obj_data.clear();
}


