#include "ReconResonance/RmatrixLimited/endf/TEXT.h"

//ClassImp( TEXT );


TEXT::TEXT() {}
TEXT::TEXT( istream& is ) { this->Store( is ); }
TEXT::TEXT( const string o ) { this->Set(o); }

TEXT::~TEXT(){}




void TEXT::Store( istream& is ){

  string xline;

    getline( is, xline ); text = xline.substr( 0, 66 );

  return;

}




void TEXT::Write( ostream& os, int mat, int mf, int mt, int* ns ) const {

  string text66(text);

    text66.resize( 66, ' ' );
  
  os << text66 << endf( mat, mf, mt, ns );

}



bool TEXT::empty() const { return text.empty(); }
int  TEXT::size () const { return text.size (); }

char  TEXT::at        ( const int i ) const { return text[i]; }
char& TEXT::at        ( const int i )       { return text[i]; }
char  TEXT::operator[]( const int i ) const { return text[i]; }
char& TEXT::operator[]( const int i )       { return text[i]; }


void TEXT::erase( const int pos, const int num ) {

  text.erase( pos, num );  return;

}

void TEXT::push_front( const char o ) {

  string temp;

    temp.push_back(o);  temp += text;  text = temp;  return;

}

void TEXT::push_back( const char o ) {

  text.push_back( o );  return;

}


void TEXT::Print( ostream& os ) const {

  os << text << endl;

}



void TEXT::Set( const string o ) {

  text = o;  //text.resize( 66, ' ' );

}


bool TEXT::Find( const string& o ) const {

  return ( text.find(o) != string::npos );

}


string TEXT::Sub( const int index, const int n ) const {

  return text.substr(index,n);

}

void TEXT::Sub( const char x, vector<string>* a ) const {
// get strings enclosed by x

  a->clear();

  bool enter(false);  string temp;

  for( int i=0; i<static_cast<int>(text.size()); i++ ) {

    if( text[i] == x && ! enter ) { temp.clear();       enter = true;  continue; }
    if( text[i] == x &&   enter ) { a->push_back(temp); enter = false; continue; }

    if( enter ) {

      temp.push_back( text[i] );

    }

  }

  return;

}


TEXT* TEXT::Replace( const int index, const int n, const string o ) {

  text.replace(index,n,o);  return this;

}

TEXT* TEXT::Replace( const string s, const string with ) {

  string::size_type  pos( text.find( s ) );

    while( pos != string::npos ) {

        text.replace( pos, s.length(), with );
	pos = text.find( s, pos + with.length() );

    }

  return this;

}


TEXT& TEXT::operator<<( const char* o ) {

  text += string(o);  return *this;

}

TEXT& TEXT::operator<<( const string& o ) {

  text += o;  return *this;

}

TEXT& TEXT::operator<<( const int& o ) {

  stringstream ss;  ss << o;

  text += ss.str();  return *this;

}

TEXT& TEXT::operator<<( const double& o ) {

  stringstream ss;  ss << o;

  text += ss.str();  return *this;

}

TEXT& TEXT::operator<<( const TEXT& o ) {

  text += o.text;  return *this;

}

TEXT& TEXT::operator<<( const Datum& o ) {

  stringstream ss;

    ss << "(X,Y)=(" << endf( o.X() ) << ',' << endf( o.Y() ) << ')';

    text += ss.str();

  return *this;

}


bool TEXT::is_blank() const {

  for( int i=0; i<static_cast<int>(text.size()); i++ ) if( text[i] != ' ' ) return false;

  return true;

}



// I/O stream

istream& operator>>( istream& is,       TEXT& o ) { o.Store( is );  return is; }
ostream& operator<<( ostream& os, const TEXT& o ) { o.Write( os );  return os; }

