#if !defined(___Class_Tabular)
    #define  ___Class_Tabular

#include <vector>
#include "ReconResonance/RmatrixLimited/numeric/Datum.h"

using namespace std;

namespace Numeric {

  class Tabular : public vector<Datum> {

    int interpcode;

   public:

    Tabular( const int code = 2 ) : interpcode(code) {}
   ~Tabular(){}

    void push_front( const Datum& o );

    double  X( const int i ) const { return this->at(i).X(); }
    double  Y( const int i ) const { return this->at(i).Y(); }
    double& X( const int i )       { return this->at(i).X(); }
    double& Y( const int i )       { return this->at(i).Y(); }

    double I() const;

    Tabular* Set( const double x1, const double x2, double (*function)( const double&, const double* ), const double* params, const double eps = 1.e-3 );

    ////ClassDef( Numeric::Tabular, 1 );

  };

}

#endif
